﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "ABMPageTemplate"  '<-------------------------------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""
	' your own variables	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage		
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)	
	Log("Connected")
		
	ws = WebSocket1		
	
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	'----------------------START MODIFICATION 4.00-------------------------------
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	'----------------------END MODIFICATION 4.00-------------------------------
	
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If		
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)		
	If page.ComesFromPageCache Then
    	' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		Log("Comes from cache")		
    	page.Refresh		
    	page.FinishedLoading		
	Else
    	If page.WebsocketReconnected Then
			Log("Websocket reconnected")
        	' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have any on the server. So we need to reload the page.
        	' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has content, reconnected but we have no content in cache
        	ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
    	Else
        	' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
        	Log("Websocket first connection")
			page.Prepare
			ConnectPage			
    	End If
	End If
	Log(ABMPageId)		
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	Log(eventName)
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	Log(eventName)
	Dim caller As Object = page.GetEventHandler(Me, eventName)
	If caller = Me Then
		If SubExists(Me, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			' BEGIN NEW DRAGDROP
			If eventName = "page_dropped" Then
				page.ProcessDroppedEvent(Params)
			End If
			' END NEW DRAGDROP
			Select Case Params.Size
				Case 0
					CallSub(Me, eventName)
				Case 1
					CallSub2(Me, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Me, eventName, PassedTables)
					Else
						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Me, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)

	theme.AddInputTheme("inputauto")
	theme.Input("inputauto").AutoCompleteZDepth = ABM.ZDEPTH_1
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Template"
	page.PageDescription = "Template"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
				
	' adding a navigation bar
	ABMShared.BuildNavigationBar(page, "Title","../images/logo.png", "", "", "")	
			
	' create the page grid
	page.AddRowsM(5,True,0,0, "").AddCells12MP(1,0,0,0,0,"")	
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
		
End Sub

public Sub ConnectPage()			
	'	connecting the navigation bar
	ABMShared.ConnectNavigationBar(page)
	'page.B4JSRunMethod("b4jscalculatedistance", "CalcDistance", Array As Object(32.9697, -96.80322, 29.46786, -98.53506, "K"))
	
	
	Dim lbl As ABMLabel
	lbl.Initialize(page,"fdsafda","Modal",ABM.SIZE_PARAGRAPH,False,"")
	lbl.Clickable = True
	
	page.Cell(1,1).AddComponent(lbl)
	page.AddModalSheetTemplate(BuildLoginSheet)
	
	' refresh the page
	page.Refresh
	
	' Tell the browser we finished loading
	page.FinishedLoading
	' restoring the navigation bar position
	page.RestoreNavigationBarPosition	

End Sub


' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If

	ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub


'@@@@@@@@@@@@@@@@@@@

'***************************************8




public Sub BuildModalSheets()
	' add a modal sheet template to enter contact information
	page.AddModalSheetTemplate(BuildLoginSheet)
	page.AddModalSheetTemplate(BuildWrongInputModalSheet)

End Sub


public Sub ShowLogin()

	page.ShowModalSheet("login")
End Sub

public Sub CancelLogin()
	
	page.CloseModalSheet("login")
	
End Sub

Sub BuildLoginSheet() As ABMModalSheet
	Dim myModal As ABMModalSheet
	myModal.Initialize(page, "login", False,  False,"modal")
	myModal.Content.UseTheme("")
	myModal.Footer.UseTheme("")
	myModal.IsDismissible = True
	myModal.MaxWidth = "400px"
	myModal.MaxHeight = "350px"

#Region NOT SAVED: 2020-05-17T07:19:29
	'PHONE
	'╔═══════════════════════════════════════════════════════════════════════════════════╗
	'║ 1,1                                                                               ║
	'║-----------------------------------------------------------------------------------║
	'║ 1,2                                                                               ║
	'║-----------------------------------------------------------------------------------║
	'║ 1,3                                                                               ║
	'║-----------------------------------------------------------------------------------║
	'║ 1,4                              | 1,5         | 1,6                              ║
	'╚═══════════════════════════════════════════════════════════════════════════════════╝

	'TABLET
	'╔═══════════════════════════════════════════════════════════════════════════════════════════════════════════╗
	'║ 1,1                                                                                                       ║
	'║-----------------------------------------------------------------------------------------------------------║
	'║ 1,2                                                                                                       ║
	'║-----------------------------------------------------------------------------------------------------------║
	'║ 1,3                                                                                                       ║
	'║-----------------------------------------------------------------------------------------------------------║
	'║ 1,4                                        | 1,5             | 1,6                                        ║
	'╚═══════════════════════════════════════════════════════════════════════════════════════════════════════════╝

	'DESKTOP
	'╔═══════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════╗
	'║ 1,1                                                                                                                               ║
	'║-----------------------------------------------------------------------------------------------------------------------------------║
	'║ 1,2                                                                                                                               ║
	'║-----------------------------------------------------------------------------------------------------------------------------------║
	'║ 1,3                                                                                                                               ║
	'║-----------------------------------------------------------------------------------------------------------------------------------║
	'║ 1,4                                                  | 1,5                 | 1,6                                                  ║
	'╚═══════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════╝

	myModal.Content.AddRowsM(1,True,-10,0,"").AddCells12(3,"celulacentralizadaprincipal").AddCellsOS(1,0,0,0,5,5,5,"celulaalinhadaaesquerdaprincipal").AddCellsOS(1,0,0,0,2,2,2,"").AddCellsOS(1,0,0,0,5,5,5,"celulaalinhadaadireitaprincipal")
	myModal.Content.BuildGrid ' IMPORTANT!
#End Region


	Dim inp1 As ABMInput
	inp1.Initialize(page, "logininp1", ABM.INPUT_TEXT, "user",  False, "inputverde")
	inp1.B4JSUniqueKey = inp1.ID & "js"
'	inp1.B4JSOnKeyDown("ApoioB4JS", "loginkeydown", Array As Object(ABM.B4JS_PARAM_INPUTKEY))
'	inp1.B4JSOnKeyUp("ApoioB4JS", "loginkeyup", Array As Object(ABM.B4JS_PARAM_INPUTKEYCODE))
	myModal.Content.Cell(1,2).AddComponent(inp1)

	
	Dim inp2 As ABMInput
	inp2.Initialize(page, "logininp2", ABM.INPUT_PASSWORD,"password", False, "inputverde")
'	inp2.B4JSUniqueKey = inp2.ID & "js"
'	inp2.B4JSOnKeyDown("ApoioB4JS", "passwordkeydown", Array As Object(ABM.B4JS_PARAM_INPUTKEY))
'	inp2.B4JSOnKeyUp("ApoioB4JS", "passwordkeyup", Array As Object(ABM.B4JS_PARAM_INPUTKEYCODE))
	
	myModal.Content.Cell(1,3).AddComponent(inp2)
	myModal.Content.Cell(1,3).MarginTop = "-10px"
	
	
	Dim msbtn1 As ABMButton
	msbtn1.InitializeFlat(page, "loginbtn", "", "", "Login", "botaoBuscar")
	myModal.Content.Cell(1,4).AddComponent(msbtn1)
	
	Dim lbl As ABMLabel
	lbl.Initialize(page,"asdfasdf","{NBSP}",ABM.SIZE_PARAGRAPH,False,"")
	myModal.Content.Cell(1,5).AddComponent(lbl)

	' create the button for the footer
	Dim msbtn2 As ABMButton
	msbtn2.InitializeFlat(page, "logincancelbtn", "", "", "Cancel", "botaoBuscar")

	myModal.Content.Cell(1,6).AddComponent(msbtn2)
	Return myModal
End Sub

Sub BuildWrongInputModalSheet() As ABMModalSheet
	Dim myModalError As ABMModalSheet
	myModalError.Initialize(page, "wronginput", False, False, "modal")
	myModalError.IsDismissible = True
	
	' create the grid for the content
	myModalError.Content.AddRows(1,True, "").AddCells12(1,"")
	myModalError.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "contlbl1", "User or password incorrect!",ABM.SIZE_PARAGRAPH, False, "")
	myModalError.Content.Cell(1,1).AddComponent(lbl1)
	
	Return myModalError
End Sub


Sub fdsafda_Clicked(Target As String)
	page.ShowModalSheet("login")
End Sub
 
 
public Sub HandleLogin(LoginFromPage As String)

	Log(80)
	Dim x As ABMModalSheet = page.ModalSheet("login")
	If page.ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
		Log(90)

		'if the next line is commented problem does not happen
		Dim y As ABMInput = x.Content.Component("logininp1")
		
	End If

'	'  user was successful in login.  Now navigate to xxx...
	page.CloseModalSheet("login")
	

End Sub


' handle the login and cancel buttons from the login in form.
Sub loginbtn_Clicked(Target As String)

	HandleLogin(Name)
End Sub

Sub logincancelbtn_Clicked(Target As String)

	CancelLogin
End Sub

Sub logininp2_enterpressed(value As String)
	Log("logininp2_enterpressed")

	HandleLogin(Name)

End Sub


Sub logininp1_enterpressed(Target As String)

	Log("logininp1_enterpressed")
End Sub
